public class Circle implements Shape {

    public Circle(Point2D center, double radius) {
        this.center = center.clone();
        this.radius = radius;
        updateArea();
    }
    /*
     * Attention on ne peut pas lier l'implémentation de Circle à Point2DCartesien
     *  Ce constructeur ne devrait pas exister.
     */
    public Circle(double radius) {
        this.radius = radius;
        updateArea();
    }

    public double getArea() {
        return area;
    }

    public Point2D getCenter() {
        if (center == null) throw new RuntimeException("Circle n'a pas de centre");
        return center.clone();
    }

    public void setCenter(Point2D p) {
        center = p.clone();
    }

    public double getRadius(){
        return radius;
    }

    public void setRadius(double radius){
        this.radius = radius;
        updateArea();
    }

    public Shape clone() {
        if (center == null)
            return new Circle(radius);
        return new Circle(center, radius);
    }

    public String toString() {
        StringBuffer buff = new StringBuffer();
        buff.append("Cercle de centre:");
        buff.append(center);
        buff.append(" et de rayon: ");
        buff.append(radius);
        return buff.toString();
    }

    public boolean equals(Circle c) {
        if (center != null && c.center != null)
            return center.equals(c.center) && radius == c.radius;
        if (center == null)
            return c.center == null && radius == c.radius;
        return false;
    }

    public boolean equals(Shape sh) {
        if(sh instanceof Circle ){   
            return equals((Circle)sh);
        }
        return false;
    }

    private void updateArea() {
        area = Math.PI * radius * radius;
    }

    public Shape translation(Point2D p) {
        center.translation(p);
        return this;
    }
    public Shape rotation(double angle) {
        center.rotation(angle);
        return this;
    }

    public Shape homothetie(double rapport) {
        center.homothetie(rapport);
        return this;
    }

    public Shape rotation(Point2D center, double angle) {
        this.center.rotation(center, angle);
        return this;
    }

    public Shape homothetie(Point2D center, double rapport) {
        this.center.homothetie(center, rapport);
        return this;
    }

    private Point2D center;
    private double radius;
    private double area;

}