public class Hanoi {

    //1er test simple du polymorphisme
    // public static void main(String[] args){
    // 	int n = 10;
    // 	Shape[] t = new Shape[n*2];
    // 	for (int r = 1; r <=n; ++r){
    // 	    Circle c = new Circle(r);
    // 	    t[2*r-2] = c;
    // 	    Square sq = new Square(2*r);
    // 	    t[2*r-1] = sq;

    // 	}
    // 	for (int i = 0; i < t.length; ++i){
    // 	    System.out.print (t[i]);
    // 	    System.out.println (" " + t[i].getArea());
    // 	}
    // }

    // test du polymorphisme avec une pile de formes
    /*public static void main(String[] args){
    	int n = 5;
    	ShapeStack stack = new ShapeStackFixedSizeArray(n*2);
    	for (int r = 1; r <=n; ++r){
    	    Circle c = new Circle(r);
    	    stack.push(c);
    	    Square sq = new Square(2*r);
    	    stack.push(sq);
    	}
    	System.out.println (stack);
    	while (!stack.isEmpty()) {
    	    Shape s = stack.top();
	    stack.pop();
    	    System.out.println (s.getArea());
    	}
    }*/



    // Algorithme des tours de Hanoi     
    public static void moveShapes(ShapeStack fromTower, ShapeStack toTower, ShapeStack viaTower, int nbShapes){
        if (nbShapes > 0) {
            moveShapes (fromTower, viaTower, toTower, nbShapes-1);
            toTower.push(fromTower.top());
            fromTower.pop();
            moveShapes (viaTower, toTower, fromTower, nbShapes-1);
        }
    }


    public static void main(String[] args){
        int n = 2;
        // 	// Création des trois tours de formes
        ShapeStack tower0 = new ShapeStackFixedSizeArray (n*2);
        ShapeStack tower1 = new ShapeStackFixedSizeArray (n*2);
        ShapeStack tower2 = new ShapeStackFixedSizeArray (n*2);

        // La première tour est remplie de formes d'aires croissantes
        for (int r = 1; r <=n; ++r){
            Circle c = new Circle(r);
            tower0.push(c);
            Square sq = new Square(2*r);
            tower0.push(sq);
        }

        // Affichage des trois tours avant les déplacements
        System.out.println ("Avant les déplacements");
        System.out.println("Tour 1: ");
        System.out.println(tower0);
        System.out.println("Tour 2: ");
        System.out.println(tower1);
        System.out.println("Tour 3: ");
        System.out.println(tower2);

        // Déplacement des formes de la 1ère tour vers la 3ième
        Hanoi.moveShapes(tower0, tower2, tower1, n*2);

        // Affichage des trois tours après les déplacements
        System.out.println ("Après les déplacements");
        System.out.println("Tour 1: ");
        System.out.println(tower0);
        System.out.println("Tour 2: ");
        System.out.println(tower1);
        System.out.println("Tour 3: ");
        System.out.println(tower2);


    }



}