public abstract class Point2DAbstract implements Point2D {

    public abstract Point2D clone();

    public boolean equals(Point2D p) {
        return Math.abs(this.getAbscisse()-p.getAbscisse()) + Math.abs(this.getOrdonnee() - p.getOrdonnee()) < EPSILON;
    }

    public String toString() {
        return "(x:" + getAbscisse() + ", y:" + getOrdonnee() + ") [rho: " + getModule() + "," + " theta:" + getArgument() + "]";
    }

    public Point2D translation(double dx, double dy) {		
        setAbscisse(getAbscisse() + dx);
        setOrdonnee(getOrdonnee() + dy);
        return this;
    }

    public Point2D rotation(double angle) {
        this.setArgument(getArgument() + angle);
        return this;
    }

    public Point2D homothetie(double rapport) {
        setModule(getModule() * rapport);
        return this;
    }

    public Point2D homothetie(Point2D center, double rapport) {
        center.homothetie(-1.);
        this.translation(center);
        this.homothetie(rapport);
        center.homothetie(-1.);
        this.translation(center);		
        return this;
    }

    public Point2D rotation(Point2D center, double angle) {
        center.homothetie(-1.);
        this.translation(center);
        this.rotation(angle);
        center.homothetie(-1.);
        this.translation(center);		
        return this;
    }

    public Point2D translation(Point2D vec) {	
        return translation(vec.getAbscisse(), vec.getOrdonnee());
    }

}