public class Point2DCartesien extends Point2DAbstract {

    public Point2DCartesien(double x, double y){
        this.x = x;
        this.y = y;
    }

    public Point2DCartesien(Point2D p){
        this(p.getAbscisse(), p.getOrdonnee());
    }

    public Point2DCartesien(){
        this(0,0);
    }

    public double getAbscisse(){
        return this.x;
    }

    public void setAbscisse(double x){
        this.x = x;
    }

    public double getOrdonnee(){
        return this.y;
    }

    public void setOrdonnee(double y){
        this.y = y;
    }

    public double getModule(){
        return Math.sqrt(this.x*this.x+this.y*this.y);
    }

    public void setModule(double module){
        double arg = this.getArgument();
        setAbscisse(module * Math.cos(arg));
        setOrdonnee(module * Math.sin(arg));
    }

    public double getArgument(){
        return Math.atan2(this.y,this.x);
    }

    public void setArgument(double argument){
        double m = this.getModule();
        setAbscisse(m * Math.cos(argument));
        setOrdonnee(m * Math.sin(argument));
    }


    public Point2D clone(){
        return new Point2DCartesien (x, y);
    }

    double x;
    double y;

}
