public class Point2DPolaire extends Point2DAbstract {

    public Point2DPolaire(double rho, double theta){
        this.rho = rho;
        this.theta = theta;
    }

    public Point2DPolaire(Point2D p){
        this(p.getModule(), p.getArgument());
    }

    public Point2DPolaire(){
        this(0,0);
    }

    public double getAbscisse(){
        return this.rho * Math.cos(this.theta);
    }

    public void setAbscisse(double x){
        double y = getOrdonnee();
        rho = Math.sqrt(x*x+y*y);
        theta = Math.atan2(y, x);		
    }

    public double getOrdonnee(){
        return this.rho * Math.sin(this.theta);
    }

    public void setOrdonnee(double y){
        double x = getAbscisse();
        rho = Math.sqrt(x*x+y*y);
        theta = Math.atan2(y, x);		
    }

    public double getModule(){
        return rho;
    }

    public void setModule(double module){
        rho = module;
    }

    public double getArgument(){
        return theta;
    }

    public void setArgument(double argument) {
        theta = argument;
    }

    public boolean equals(Point2D p){
        return Math.abs(this.rho-p.getModule()) + Math.abs(this.theta - p.getArgument()) < EPSILON;
    }

    public Point2D clone(){
        return new Point2DPolaire (rho, theta);
    }

    private double rho;
    private double theta;

}
