public abstract class ShapeStackAbstract implements ShapeStack {

    public abstract ShapeStack clone();

    public boolean equals(ShapeStack s) {
        ShapeStack thisC = (ShapeStack) this.clone();
        ShapeStack sC   = (ShapeStack) s.clone();
        while(!thisC.isEmpty() && !sC.isEmpty()) {
            if(thisC.top() != sC.top())
                return false;
            thisC.pop();
            sC.pop();
        }
        return thisC.isEmpty() && sC.isEmpty();
    }

    public String toString(){
        StringBuffer s = new StringBuffer("[ ");
        ShapeStack copy = (ShapeStack) this.clone();
        while(!copy.isEmpty()) {
            s.append(copy.top());
            copy.pop();
            if (!copy.isEmpty()) s.append(",");
        }
        s.append("]");
        return s.toString();
    }
}
