public abstract class ShapeStackArrayAbstract extends ShapeStackAbstract {

    public ShapeStackArrayAbstract(int maxSize){
        shapes = new Shape[maxSize];
        this.indexTop= 0;
    }

    public boolean equals(ShapeStackArrayAbstract s) {
        if (s.indexTop!= indexTop) return false;
        for (int i=0; i<indexTop; ++i)
            if (s.shapes[i] != shapes[i]) return false;
        return true;
    }

    public boolean equals(ShapeStack s) {
        if (s instanceof ShapeStackArrayAbstract) 
            return equals((ShapeStackArrayAbstract) s);
        return super.equals(s);
    }

    public void push(Shape s){
        if(isFull()) 
            manageStack();
        shapes[indexTop++] = s;
    }

    public void pop(){
        if(!isEmpty()) {
            --indexTop;
            shapes[indexTop] = null; //Sinon le garbage collector ne peut pas vider la mémoire.
        }
    } 

    public Shape top(){
        if(!isEmpty())
            return shapes[indexTop - 1];
        throw new RuntimeException("Stack Empty");
    }

    public boolean isEmpty(){
        return indexTop == 0;
    }

    public boolean isFull(){
        return indexTop == shapes.length;
    }

    protected abstract void manageStack();

    protected Shape[] shapes;
    protected int indexTop = 0;
}
