public class Square implements Shape {

    public Square(Point2D bottomLeftCorner, Point2D topRightCorner) {
        corners = new Point2D[2];
        corners[0] = bottomLeftCorner.clone();
        corners[1] = topRightCorner.clone();
        if (!testValidCorners(corners)){
            System.out.println("Carré invalide il faut lever une exception !!!");
        }
        updateArea();
    }

    public Square(Point2D center, double side) {
        corners = new Point2D[2];
        corners[0] = new Point2DCartesien(center.getAbscisse()-side/2, center.getOrdonnee()-side/2);
        corners[1] = new Point2DCartesien(center.getAbscisse()+side/2, center.getOrdonnee()+side/2);
        updateArea();
    }

    public Square(double side) {
        corners = new Point2D[2];
        corners[0] = new Point2DCartesien(-side/2, -side/2);
        corners[1] = new Point2DCartesien(side/2, side/2);
        updateArea();
    }

    public double getArea() {
        return area;
    }

    public Point2D getBottomLeftCorner() {
        return corners[0].clone();
    }

    public Point2D getTopRightCorner() {
        return corners[1].clone();
    }

    public void setBottomLeftCorner(Point2D p) {
        corners[0] = p.clone();
        if (!testValidCorners(corners)){
            System.out.println("Carré invalide il faut lever une exception !");
        }
        updateArea();
    }

    public void setTopRightCorner(Point2D p) {
        corners[1] = p.clone();
        if (!testValidCorners(corners)){
            System.out.println("Carré invalide il faut lever une exception !");
        }
        updateArea();
    }

    public Shape clone() {
        return new Square(corners[0], corners[1]);
    }
    public String toString() {
        return "(Square : " + corners[0] + "," + corners[1] + ")";
    }

    public boolean equals(Shape sh) {
        if(sh instanceof Square)
        {
            Square sq= (Square) sh;
            return corners[0].equals(sq.corners[0]) && corners[1].equals(sq.corners[1]);
        }
        else
            return false;
    }

    private void updateArea() {
        double side =  corners[1].getAbscisse()-corners[0].getAbscisse();
        area = side*side;
    }

    private boolean testValidCorners(Point2D [] corners){
        double x0 = corners[0].getAbscisse();
        double y0 = corners[0].getOrdonnee();
        double x1 = corners[1].getAbscisse();
        double y1 = corners[1].getOrdonnee();
        return x0 <= x1 && y0 <= y1 && x1-x0 == y1-y0; 
    }

    private Point2D [] corners;
    private double area;

    public Point2D getCenter() {
        return corners[0].clone().translation(corners[1]).homothetie(1./2.);
    }

    public Shape translation(Point2D p) {
        for(int i=0;i<corners.length; ++i)
            corners[i].translation(p);
        return this;
    }

    public Shape rotation(double angle) {
        for(int i=0;i<corners.length; ++i)
            corners[i].rotation(angle);
        return null;
    }

    public Shape homothetie(double rapport) {
        for(int i=0;i<corners.length; ++i)
            corners[i].homothetie(rapport);
        return this;
    }

    public Shape rotation(Point2D center, double angle) {
        for(int i=0;i<corners.length; ++i)
            corners[i].rotation(center, angle);
        return this;
    }

    public Shape homothetie(Point2D center, double rapport) {
        for(int i=0;i<corners.length; ++i)
            corners[i].homothetie(center, rapport);
        return this;
    }

}